/**
 *  deffuantThreshold
 *  Author: hg
 *  Description: 
 */
model deffuantThreshold

global {
	int nAgents <- 10;
	float threshold <- 0.3;
	float convergenceParam <- 0.5;
	
	init {
		create SimpleAgent number: nAgents;
	}
}

species SimpleAgent {
	float opinion <- rnd(1.0) min: 0.0 max: 1.0;

	reflex discute {
		SimpleAgent neighbor <- any(SimpleAgent - self);
		
		if (neighbor != nil) and ((abs(neighbor.opinion - opinion)) < threshold) {	
			// x = x + u* (x - x')
			float temp <- opinion;
			opinion <- opinion + convergenceParam * (neighbor.opinion - opinion);
			neighbor.opinion <- neighbor.opinion + convergenceParam * (temp - neighbor.opinion);
		}
	}
}

experiment deffuantThreshold type: gui {
	parameter "Number of Agents"  var: nAgents <- 10;
	parameter "Threshold" var: threshold <- 0.3;
	parameter "Convergence speed" var: convergenceParam <- 0.5;
	
	output {
		
		display deffuant { 
			chart "Time chart" type: series background: rgb('white') {
				loop a over: SimpleAgent {
			 		data ""+int(a) value: a.opinion color: rgb('blue');
			 	}
			 }
		}
	}
}
