/**
* Name: scheduling
* Author: bgaudou
* Description: Describe here the model and its experiments
* Tags: Tag1, Tag2, TagN
*/

model scheduling

global {
	list<int> lvalues <- [];
	int N <- 10;
	
	init {
		create people number: N;
	}
	
	reflex updateList {
		loop times: N {
			add rnd(1000) to: lvalues;
		}
	}
}

species people 
	schedules: (people sort_by each.money) { 
	// schedules: shuffle(people) {
	int money <- 0;
	
	reflex upd {
		int max <- max(lvalues);
		remove max from: lvalues;
		money <- money + max;
		
		write 'self ' + self + " " + lvalues + " - cycle : " + cycle;
	}
}

experiment scheduling type: gui {
	output {
		display d {
			chart "c" type: series {
				data "diff" value: (people max_of(each.money)) - (people min_of(each.money));
			}
		}
	}
}
