/**
* Name: ExoContainers
* Author: bgaudou
*/
model ExoContainers

global {

	init {
	// Declare and create a list of 10 chosen integer numbers in [0,10].
	// (hints: variable declaration, create a list)
		list<int> my_l <- [9, 7, 2, 8, 2, 6, 1, 0, 8, 3];
		write sample(my_l);

		// Write in the console the number of elements of the list.
		//(hint: length operator)
		int l <- length(my_l);
		write l;

		// Get the first element of the list.
		// (hint: first operator)
		int f_i <- first(my_l);
		write f_i;

		// Reverse the order of the elements of the list.
		// (hint: reverse operator)
		list<int> rev_l <- reverse(my_l);
		write rev_l;

		// Get the last element of the list.
		int f_rev <- first(reverse(my_l));
		write f_rev;

		// Get the last element of the list.
		// (hint: last operator)
		int l_i <- last(my_l);
		write l_i;

		// Sort the element by ascending order.
		// (hint: sort_by operator)
		list<int> s_l <- my_l sort_by (each);
		write s_l;

		// Sort the element by descending order.
		list<int> rev_rev <- reverse(my_l sort_by (each));
		write rev_rev;

		// Get a new list with only the elements greater or equals to 5.
		// (hint: where operator)
		list<int> sel_5 <- my_l where (each >= 5);
		write sel_5;

		// Get the list of elements organised as follow: first the elements lower than 5, ordered by ascending order and then the elements greater or equals to 5, ordered by descending order.
		//(hint: + operator to concatenate lists)	
		list<int> sel <- ((my_l where (each < 5)) sort_by (each)) + reverse((my_l where (each >= 5)) sort_by (each));
		write sel;

		// Get the list of all the elements multiplied by 10
		// (hint: accumulate/collect operator)
		list<int> l10 <- my_l accumulate (each * 10);
		write l10;

		// Get the list of the square of elements greater than 5.
		list<int> sq <- (my_l where (each > 5)) accumulate (each * each);
		write sq;


		////////////////////////////////////  ////////////////////////////////////
		// Define a species people, with 2 attributes: energy and money (random float values between 0.0 and 10.0).
		// Create 10 agents people.
		create people number: 10;

		// Get the list of people with energy greater than 5.
		list<people> lp5 <- people where (each.energy > 5);
		write lp5;

		// Get a list of 3 random people agents.
		// (hint: among operator)
		list<people> lp3 <- 3 among people;
		write lp3;

		//Get the people agent with the max of energy, with the min of money.
		//(hint: with_min_of, with_max_of operators)
		people pMaxE <- people with_max_of (each.energy);
		write pMaxE;
		people pMinM <- people with_min_of (each.money);
		write pMinM;

		//Get the maximum value of money, the minimum value of energy among the people agents.
		//(hint: min_of, max_of operators)
		float maxM <- people max_of (each.money);
		float minE <- people min_of (each.energy);
		write '' + maxM + " --  minE: " + minE;

		//Get the list of all the energy values.
		list<float> enVal <- people accumulate (each.energy);
		write enVal;

		//Get the list of people sorted by money.
		list<people> lpM <- people sort_by (each.money);
		write lpM;

		//Get the list of people with energy greater than 3 and lower than 6.
		list<people> lpE <- people where ((each.energy > 3) and (each.energy < 6));
		write lpE;

		//Get the people agent with the lowest money among people agents with energy greater than 2.
		people pLowMon <- (people where (each.energy > 2)) with_min_of (each.money);
		write pLowMon;

		//Check (i.e. get true of false) whether there is a people agent with money greater than 9. 
		//(hint: empty operator)
		bool g9 <- empty(people where (each.money > 9));
		write g9;
		
		
		write "/////////////////////// MAP /////////////";

		//Define a map variable containing elements of type string (for the key) and float (for the value), initialize it at hand with 3 pairs (with at least 1 key starting with “a” letter).
		map<string, float> myMap <- map<string, float>(["ab"::2, "ba"::8, "cda"::1]);
		write myMap;

		//Get the list of all the values of the map.
		list<float> lf <- myMap.values;
		write lf;

		//Get the map of pairs where the key start with the letter “a”
		map<string, float> myMapP <- map<string, float>(myMap.pairs where (first(each.key) = "a"));
		write myMapP;

		//Given people agents of the previous question, get the map of people name and people nergy.		
		map<string, float> mPeop <- map<string, float>(people collect ((each.name)::(each.energy)));
		write mPeop;

		//Get the map associating the name of the people agent, with the list of its 3 coordinates.
		map<string, list<float>> mPt <- map<string, list<float>>(people collect ((each.name)::[each.location.x, each.location.y, each.location.z]));
		write mPt;
	}

}

species people {
	float energy <- rnd(10.0);
	float money <- rnd(10.0);
}

experiment ExoContainers type: gui {
	output {
	}

}
