/**
* Name: inherit
* Author: bgaudou
* Description: Describe here the model and its experiments
* Tags: Tag1, Tag2, TagN
*/

model inherit

global {
	list<plot> all_plots;
	
	init {
		create Rnd_Buyer;
		create Maxi_buyer;
		
		create energyProducer number: 10;
		create farm number: 10;		
		create randomProducer number: 10;		
		
		all_plots <- agents of_generic_species(plot);
	}
}

species buyer  {
	reflex R_choosePlot {
		write self.choosePlot();
	}
	
	plot choosePlot {
		return nil;
	}
}

species Rnd_Buyer parent: buyer {
	plot choosePlot {
		list<float> l_values <- all_plots accumulate ((each.getBiomass()) * (each.getN()));
		plot choosen_one <- all_plots[rnd_choice(l_values)];
		write "Agt: " + self + " - " + choosen_one;
		return choosen_one;
	}	
}

species Maxi_buyer parent: buyer {
	plot choosePlot {
		plot choosen_one <- all_plots with_max_of((each.getBiomass()) * (each.getN()));
		write "Agt: " + self + " - " + choosen_one;
		return choosen_one;
	}	
}

species plot {
	float getBiomass {
		return 0.0;
	}
	float getN {
		return 0.0;
	}
}

species energyProducer parent: plot {
	float biomass <- rnd(10.0);
	
	float getBiomass {
		return biomass;
	}	
}

species farm  parent: plot {
	float biomass <- rnd(10.0);
	float N <- rnd(10.0);
	
	float getBiomass {
		return biomass;
	}
	float getN {
		return N;
	}	
}

species randomProducer parent: plot {
	float N <- rnd(10.0);

	float getN {
		return N;
	}	
}

experiment inherit type: gui {
	output { }
}
